uses crt;

const
{$I keycodes.pas}
   OKSET       = ['A'..'Z','a'..'z','0'..'9','-',#32,#8];

type
KeyPress=record
Ch:char;
Code:integer;
end;
CDType=record
Title,Author,Publisher,comment,favoritetrack,year,rating:string;
end;
DataPtr=^DataRec;
DataRec=record
CD:CDType;
Next,Prev:DataPtr;
end;

var
readchecksum,writechecksum:byte;
readletter,writeletter:byte;
readaccess,writeaccess:integer;
current:dataptr;
Top:DataPtr;
Key,key2:keypress;
DatabaseFile,DatabaseTitle:string;
CurrRec,NumRecs:integer;
TempCD:CDTYPE;
infile,outfile:file of byte;
DatabaseOpen:boolean;
msgbool:boolean;
msgcount:integer;
msg:string;
msgx,msgy:integer;
wx1,wx2,wy1,wy2:integer;

procedure setwindow(x1,y1,x2,y2:integer);
begin
     wx1:=x1;
     wx2:=x2;
     wy1:=y1;
     wy2:=y2;
     window(x1,y1,x2,y2);
end;

function generatechecksum(data:string):byte;
var
x:integer;
tempcheck:longint;
begin
     tempcheck:=0;
     for x:=1 to length(data) do tempcheck:=tempcheck+byte(data[x]);
     generatechecksum:=tempcheck;
end;

procedure writestring(data:string);
var x:integer;
begin
     write(outfile,byte(data[0]));
     for x:=1 to length(data) do write(outfile,byte(data[x]));
end;

function readstring:string;
var x:byte;
z:integer;
ch:char;
tempstr:string;
begin
     ch:=#0;
     read(infile,x);
     for z:=1 to x do read(infile,byte(tempstr[z]));
     tempstr[0]:=char(x);
     readstring:=tempstr;
end;

procedure killlist(var head:dataptr);
var
temprec:dataptr;
begin

temprec:=head;
if temprec<>nil then
begin
repeat
      if(temprec^.prev<>nil) then dispose(temprec^.prev);
      if temprec^.next=nil then dispose(temprec);
      if(temprec<>nil) then temprec:=temprec^.next;
until temprec=nil;
end;
end;

procedure initlist(var head:dataptr);
begin
head:=nil;
end;

procedure godowna(var head:dataptr);
begin
if head^.next<>nil then head:=head^.next;
end;

procedure goupa(var head:dataptr);
begin
if head^.prev<> nil then head:=head^.prev;
end;

procedure gotoend(var head:dataptr);
begin
repeat godowna(head) until head^.next=nil;
end;

procedure gotobegin(var head:dataptr);
begin
repeat goupa(head) until head^.prev=nil;
end;

procedure goup(var head:dataptr);
begin
if head^.prev<> nil then
begin
     head:=head^.prev;
     currrec:=currrec-1;
end
else
begin
     gotoend(head);
     currrec:=numrecs-1;
     sound(220);
     delay(100);
     nosound;
end;
end;

procedure godown(var head:dataptr);
begin
if head^.next<>nil then
begin
     head:=head^.next;
     currrec:=currrec+1;
end
else
begin
     gotobegin(head);
     currrec:=0;
     sound(220);
     delay(100);
     nosound;
end;
end;

function GoToNumberedRec(head:dataptr; whichrec:integer):dataptr;
var x:integer;
begin
for x:=2 to whichrec do godowna(head);
GoToNumberedRec:=head;
end;

procedure delete(node:dataptr);
begin
if node^.prev<>nil then node^.prev^.next:=node^.next;
if node^.next<>nil then node^.next^.prev:=node^.prev;
dispose(node);
end;

procedure insert(var head:dataptr; tempcd:cdtype);
var
current:dataptr;
newrec:dataptr;
found:boolean;

begin
new(newrec);
newrec^.cd.title:=tempcd.title;
newrec^.cd.author:=tempcd.author;
newrec^.cd.publisher:=tempcd.publisher;
newrec^.cd.comment:=tempcd.comment;
newrec^.cd.favoritetrack:=tempcd.favoritetrack;
newrec^.cd.year:=tempcd.year;
newrec^.cd.rating:=tempcd.rating;
newrec^.next:=nil;
newrec^.prev:=nil;
found:=false;
if head=nil then
begin
     head:=newrec;
end
else
if head^.next=nil then
begin
     head^.next:=newrec;
     newrec^.prev:=head;
end
else
begin
     newrec^.next:=head^.next;
     head^.next:=newrec;
     newrec^.prev:=head;
     newrec^.next^.prev:=newrec;
end;
end;

procedure GetKeypress(var Key:Keypress);
var x:integer;
oldx,oldy:integer;
begin
     key.code:=0;
     oldx:=wherex;
     oldy:=wherey;
     while not keypressed do
     begin
          delay(10);
          if(msgbool=true) then
          begin
               dec(msgcount);
               if(msgcount=0) then
               begin
                    window(1,1,80,25);
                    gotoxy(msgx,msgy);
                    msgbool:=false;
                    for x:=1 to length(msg) do write(' ');
                    window(wx1,wy1,wx2,wy2);
               end
               else
               begin
                    window(1,1,80,25);
                    gotoxy(msgx,msgy);
                    writeln(msg);
                    window(wx1,wy1,wx2,wy2);
               end;
          end;
     end;
     Key.ch:=readkey;
     if(byte(key.ch)=0) then key.code:=byte(readkey);
     gotoxy(oldx,oldy);
end;

procedure CK(var key:keypress);
begin
     key.code:=0;
     key.ch:=#0;
end;

procedure GetCDData(var CD:CDType);
   VAR
      THROUGH : BOOLEAN;  { input exit flag }
      POS     : INTEGER;  { input position  }

   PROCEDURE SCREEN_DISPLAY;
      VAR
         X : STRING[12];
         y,z:integer;
      BEGIN  { display_screen }
         CLRSCR;
         setwindow(9,2,70,4);
         CLRSCR;
         WRITELN(' ͻ');
         WRITELN('                                                          ');
           WRITE(' ͼ');
                  gotoxy(30-length(databasetitle) div 2,2);
         write(databasetitle);

         setwindow(9,7,70,23);
         CLRSCR;
         WRITELN(' ͻ');
         WRITELN('   Input Data At The Cursor.                               ');
         WRITELN(' Ķ');
         WRITELN('                                                           ');
         WRITELN('   Author    :  Publisher:   ');
         WRITELN('                                                           ');
         WRITELN('                   Fav.Trak:    Year:              ');
         WRITELN('                                                           ');
         WRITELN('   Comment       :   ');
         WRITELN('                                                           ');
         WRITELN('   CD  :   Rating:                  ');
         WRITELN('                                                           ');
         WRITELN(' Ķ');
         WRITELN('   Use <Lt> & <Rt> Arrow Keys to make any random changes.  ');
         WRITELN('   Press <PgDn> / <PgUp> for next / previous data record.  ');
         WRITELN('   -=-=-=-  PRESS <ESC> TO LEAVE DATA ENTRY MENU  -=-=-=-  ');
           WRITE(' ͼ');
         GOTOXY(17,5)
   END;

   PROCEDURE CLEAR;
      BEGIN
         GOTOXY(17,5);
         WRITE('');
         GOTOXY(44,5);
         WRITE('');
         GOTOXY(31,7);
         WRITE('');
         GOTOXY(44,7);
         WRITE('');
         GOTOXY(21,9);
         WRITE('');
         GOTOXY(11,11);
         WRITE('');
         gotoxy(11,40);
         write('');
         gotoxy(40,11);
         write('');
         GOTOXY(56,2);
         WRITE(CurrRec);
         gotoxy(17,5);
         write(current^.cd.author);
         gotoxy(44,5);
         write(current^.cd.publisher);
         gotoxy(31,7);
         write(current^.cd.favoritetrack);
         gotoxy(44,7);
         write(current^.cd.year);
         gotoxy(21,9);
         write(current^.cd.comment);
         gotoxy(11,11);
         write(current^.cd.title);
         gotoxy(40,11);
         write(current^.cd.rating);
      END;  { clear }


   PROCEDURE INPUT_RECORD(VAR POS : INTEGER;
                          VAR THROUGH : BOOLEAN);
      VAR
         KEY  : CHAR;      { character entered from keyboard }
         X    : INTEGER;   { horizontal gotoxy position }

      PROCEDURE MOVE_CURSOR(POS : INTEGER; X : INTEGER);
         BEGIN { move_cursor }
            CASE POS OF
               1 : GOTOXY(17+X,5);
               2 : GOTOXY(44+X,5);
               3 : GOTOXY(31+X,7);
               4 : GOTOXY(44+X,7);
               5 : GOTOXY(21+X,9);
               6 : GOTOXY(11+X,11);
               7: gotoxy(40+x,11);
            END  { case pos }
         END;  { move_cursor }

      PROCEDURE DISPLAY_CHAR(POS : INTEGER;  KEY : CHAR; VAR X : INTEGER);
         VAR
            OKPOS : INTEGER;
         BEGIN  { check_position }
            CASE POS OF
               1 : OKPOS := 16;
               2 : OKPOS := 15;
               3 : OKPOS := 4;
               4 : OKPOS := 4;
               5 : OKPOS := 40;
               6 : OKPOS := 19;
               7: OKPOS:=4;
            END;  { case pos of }
            IF KEY = #8 THEN BEGIN
               X := X - 1;
               IF X < 0 THEN X := 0;
               WRITE('');
               MOVE_CURSOR(POS,X)
            END
            ELSE BEGIN
               move_cursor(pos,x);
               X := X + 1;
               WRITE(KEY);
               IF X = OKPOS THEN
                  X := OKPOS-1;
               MOVE_CURSOR(POS,X);
            END;  { else begin }
         case pos of
         1: begin if key<>#8 then
            begin
                 current^.cd.author[x]:=key;
                 if length(current^.cd.author)<x then current^.cd.author[0]:=char(x);
            end;
            end;
         2: begin if key<>#8 then
            begin
                 current^.cd.publisher[x]:=key;
                 if length(current^.cd.publisher)<x then current^.cd.publisher[0]:=char(x);
                 end;
            end;
         3: begin if key<>#8 then begin current^.cd.author[x]:=key; current^.cd.author[0]:=char(x); end; end;
         4: begin if key<>#8 then begin current^.cd.favoritetrack[x]:=key; current^.cd.favoritetrack[0]:=char(x); end; end;
         5: begin if key<>#8 then begin current^.cd.comment[x]:=key; current^.cd.comment[0]:=char(x); end; end;
         6: begin if key<>#8 then begin current^.cd.title[x]:=key; current^.cd.title[0]:=char(x); end; end;
         7:begin if key<>#8 then begin current^.cd.rating[x]:=key; current^.cd.rating[0]:=char(x); end; end;
         end;
         END;  { check_position }

      PROCEDURE NEW_CURSOR(KEY : CHAR; VAR POS : INTEGER);
         VAR
            SCAN : INTEGER;
         BEGIN
            IF KEY = #0 THEN BEGIN
              scan:=key2.code;
               CASE SCAN OF
                  77 : POS := POS + 1; { rt-arrow }
                  75 : POS := POS - 1; { lt-arrow }
                  73 : BEGIN
                          goup(current);
                          POS := 1;
                          CLEAR;
                       END;  { pgup }
                  81 : BEGIN
                          godown(current);
                          POS := 1;
                          CLEAR END;  { pgup }
                  ELSE WRITE(#7)
               END
            END;  { if key = #0 }
            IF KEY = #13 THEN POS := POS + 1;
            IF POS = 8 THEN POS := 1;
            IF POS = 0 THEN POS := 7;
         END;  { new_cursor }

      begin  { input_record }
         X := 0;
         repeat
           getkeypress(key2);
           key:=key2.ch;
            through := key = #27;
            if not through then begin
               if KEY in OKSET then
                  DISPLAY_CHAR(POS,KEY,X);
               if (KEY = #0) or (KEY = #13) then begin
                  X := 0;
                  NEW_CURSOR(KEY,POS)
               end;  { if key = #0 }
               MOVE_CURSOR(POS,X)
            end;  { if not through }
         ck(key2);
         until through
      end;  { input_record }

   BEGIN  { input_alter_records }
      current:=gotonumberedrec(top,currrec);
      clrscr;
      through := false;
      pos := 1;
      repeat
         Screen_Display;
         clear;
         Input_Record(pos,through)
      until through;
   ck(key);
   clrscr;
   textbackground(black);
   textcolor(lightgray);
   setwindow(1,1,80,25);
   clrscr;
   end;  { input_alter_records }


procedure ChangeDatabaseTitle;
begin
clrscr;
setwindow(20,8,60,20);
writeln('Change Database Title');
writeln('---');
writeln('What would you like to change it to?');
readln(DatabaseTitle);
ck(key);
end;

procedure OpenDatabase;
var
filename:string;
begin
clrscr;
writeln('Open Database');
writeln('---');
writeln('Enter Filename:');
readln(filename);
assign(infile,filename);
reset(infile);
killlist(top);
initlist(top);
numrecs:=0;
databasetitle:=readstring;
read(infile,readchecksum);
read(infile,writeletter);
read(infile,writechecksum);
read(infile,readletter);
clrscr;
writeln('Open Database');
writeln('---');
writeln('Enter Read-access');
writeln('Password:');
readln(filename);
if(generatechecksum(filename)=readchecksum) and (filename[1]=char(readletter)) then
begin
if not eof(infile) then
begin
     msgx:=1;
     msgy:=1;
     msgcount:=200;
     msgbool:=true;
     msg:='Database Opened';
     databaseopen:=true;
     repeat
           tempcd.title:=readstring;
           tempcd.author:=readstring;
           tempcd.publisher:=readstring;
           tempcd.comment:=readstring;
           tempcd.favoritetrack:=readstring;
           tempcd.year:=readstring;
           tempcd.rating:=readstring;
           insert(top,tempcd);
           numrecs:=numrecs+1;
     until eof(infile);
end;
end
else
begin
     msgcount:=250;
     msgx:=1;
     msgy:=1;
     msgbool:=true;
     msg:='READ-LEVEL PASSWORD INVALID';
end;
close(infile);
ck(key);
end;

procedure SaveDatabase;
var
temp:string;
begin
clrscr;
writeln('Save a database');
writeln('---');
writeln('Enter Filename:');
readln(temp);
assign(outfile,temp);
clrscr;
writeln('Save a database');
writeln('---');
writeln('Enter Write-access');
writeln('Password:');
readln(temp);
if(generatechecksum(temp)=writechecksum) and (temp[1]=char(writeletter)) then
begin
rewrite(outfile);
current:=top;
writestring(databasetitle);
write(outfile,readchecksum);
write(outfile,writeletter);
write(outfile,writechecksum);
write(outfile,readletter);
repeat
      writestring(current^.cd.title);
      writestring(current^.cd.author);
      writestring(current^.cd.publisher);
      writestring(current^.cd.comment);
      writestring(current^.cd.favoritetrack);
      writestring(current^.cd.year);
      writestring(current^.cd.rating);
      godown(current);
until current^.next=nil;
     msgx:=1;
     msgy:=1;
     msgbool:=true;
     msgcount:=200;
     msg:='Database Saved';
end
else
begin
     msgx:=1;
     msgy:=1;
     msg:='WRITE-LEVEL PASSWORD INVALID';
     msgbool:=true;
     msgcount:=250;
end;
end;

procedure ViewDatabase;
begin
repeat
clrscr;
setwindow(30,8,50,20);
writeln('View Databse');
writeln('---');
writeln('F1)  Browse Records');
writeln('F2)  Search Records');
GetKeypress(key);
case key.code of
     F1:if databaseopen then GetCDData(tempcd);
end;
until byte(key.ch)=ESC;
ck(key);
end;

procedure Deleterec;
var
x:integer;
begin
repeat
clrscr;
setwindow(30,8,50,20);
writeln('Delete Record');
writeln('---');
writeln('F1) Current (',currrec,')');
writeln('F2) Enter number');
getkeypress(key);
case key.code of
     F1: delete(gotonumberedrec(top,currrec));
     F2: begin
              clrscr;
              writeln('Delete Record');
              writeln('---');
              writeln('Enter Number:');
              readln(x);
              delete(gotonumberedrec(top,x));
         end;
end;
until byte(key.ch)=ESC;
ck(key);
end;

procedure EditDatabase;
var
tempcd:cdtype;
begin
repeat
clrscr;
setwindow(30,8,50,20);
writeln('Edit Databse');
writeln('---');
writeln('F1)  Edit Record');
writeln('F2)  Add Record');
writeln('F3)  Delete Record');
GetKeypress(key);
case key.code of
     F2: begin
              databaseopen:=true;
              fillchar(tempcd,sizeof(tempcd),0);
              gotoend(current);
              insert(top,tempcd);
              numrecs:=numrecs+1;
              gotoxy(1,1);
              msgbool:=true;
              msgcount:=100;
              msg:='Record Added';
              msgx:=1;
              msgy:=1;
     end;
     F3: if databaseopen then DeleteRec;

end;
until byte(key.ch)=ESC;
ck(key);
end;

procedure passwordsettings;
var tempstring:string;
begin
clrscr;
setwindow(20,8,60,20);
writeln('Password Settings');
writeln('---');
writeln('First please enter the current');
writeln('Write-access password:');
readln(tempstring);
if(generatechecksum(tempstring)=writechecksum) and (byte(tempstring[1])=writeletter) then
begin
     clrscr;
     setwindow(20,8,60,20);
     writeln('Password Settings');
     writeln('---');
     writeln('Enter the new password for');
     writeln('Write-level access');
     readln(tempstring);
     writeletter:=byte(tempstring[1]);
     writechecksum:=generatechecksum(tempstring);
     clrscr;
     setwindow(20,8,60,20);
     writeln('Password Settings');
     writeln('---');
     writeln('Enter the new password for');
     writeln('Read-level access');
     readln(tempstring);
     readletter:=byte(tempstring[1]);
     readchecksum:=generatechecksum(tempstring);
end
else
begin
     msgbool:=true;
     msgx:=1;
     msgy:=1;
     msg:='INVALID WRITE-ACCESS PASSWORD';
     msgcount:=250;
end;
end;

procedure Housekeeping;
begin
repeat
clrscr;
setwindow(25,8,55,20);
writeln('Housekeeping Utils');
writeln('---');
writeln('F1)  Change Database Title');
writeln('F2)  Sort Entire Database');
writeln('F3)  Password Settings');
GetKeypress(key);
case key.code of
     F1: ChangeDatabaseTitle;
     F3: PasswordSettings;
end;
until byte(key.ch)=ESC;
ck(key);
end;

procedure MainMenu;
begin
repeat
     clrscr;
     setwindow(30,8,50,20);
     writeln('Main Menu');
     writeln('THE OPEN PASSWORD IS');
     writeln('GAMBRELL');
     writeln('THE SAVE PASSWORD IS');
     writeln('MATT');

     writeln('---');
     writeln('F1)  Open Database');
     writeln('F2)  Save Database');
     writeln('F3)  View Database');
     writeln('F4)  Edit Database');
     writeln('F5)  Housekeeping');
     writeln('ESC) Exit');
     GetKeypress(key);
     case (key.code) of
          F1: OpenDatabase;
          F2: SaveDatabase;
          F3: ViewDatabase;
          F4: EditDatabase;
          F5: Housekeeping;
     end;
until byte(key.ch)=ESC;
end;

begin
initlist(top);
databaseopen:=false;
textbackground(black);
textcolor(lightgray);
Top:=nil;
MainMenu;
killlist(top);
end.

